﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RodScript : MonoBehaviour
{
    public DinamicaParticella a,b; // endpoint di quest rod
    public float lenght;

    // Start is called before the first frame update
    void Start()
    {
        lenght = Vector3.Distance( a.transform.position , b.transform.position );
    }

    // Update is called once per frame
    void Update()
    {
        transform.position = (a.pos + b.pos)/2;
        transform.rotation = Quaternion.FromToRotation( Vector3.up, b.pos-a.pos);

        Vector3 newScale = transform.localScale;
        newScale.y = 0.5f * Vector3.Distance( a.pos, b.pos );
        transform.localScale = newScale;
    }

    void enforcePositionalConstraint(){
        Vector3 d = b.pos - a.pos;
        float delta = d.magnitude - lenght;
        d.Normalize();
        a.pos += (b.mass/(a.mass+b.mass)) * delta * d;
        b.pos -= (a.mass/(a.mass+b.mass)) * delta * d;
    }

    void FixedUpdate(){
        enforcePositionalConstraint();
    }
}
